/***************************************************************/
/* Prof. Dr. Carsten Vogt                                      */
/* FH Koeln, Fak. 07 / Nachrichtentechnik                      */
/* http://www.nt.fh-koeln.de/vogt                              */
/*                                                             */
/* Beispielprogramm Nr. 45                                     */
/* der frueheren Vorlesung Datenverarbeitung                   */
/*                                                             */
/* Das Programm demonstiert die Uebergabe von Arrays an Funk-  */
/* tionen: Es ist moeglich, bei der Funktionsdefinition die    */
/* Arraylaenge offenzuhalten. Arrays werden stets per Referenz-*/
/* aufruf uebergeben.                                          */
/***************************************************************/

#include <stdio.h>
#include <conio.h>

void vektorsumme(int a[],int b[],int c[],int laenge) {

 /* Die Funktion berechnet die Vektorsumme zweier int-Vektoren (= Arrays)
    a und b und speichert sie im Vektor c ab. Die Vektorsumme ist dabei
    definiert als c[i] = a[i] + b[i] fuer alle Arrayindizes i. Es wird
    vorausgesetzt, dass a, b und c gleich lang sind.
    Die Vektorlaenge ist hier nicht von vornherein festgelegt, so dass
    die Funktion hintereinander fuer Vektoren unterschiedlicher Laengen
    aufgerufen werden kann. Die konkrete Laenge wird bei einem Aufruf im
    Parameter laenge angegeben.
    Da Arrays stets per Referenzaufruf uebergeben werden, hat die Aenderung
    von c in der Funktion unmittelbare Auswirkung auf den aktuellen Para-
    meter, d.h. den zu besetzenden Summenarray im aufrufenden Programm. */

 /* Berechnung der Komponentensummen in einer Schleife */

 int i;
 for (i=0;i<laenge;i++)
  c[i] = a[i]+b[i];

}

main() {

 /* Das Hauptprogramm enthaelt zwei Vektoren (= Arrays) x und y,
    deren Vektorsumme berechnet und im Vektor summe gespeichert
    werden soll. Die Berechnung selbst wird durch die Funktion
    vektorsumme() durchgefuehrt. */

 int x[5] = {1,3,5,7,9},   /* erster Summand, mit Initialisierung */
     y[5] = {2,4,6,8,10},  /* zweiter Summand, mit Initialisierung */
     summe[5],             /* zur Aufnahme der berechneten Summe */
     i;                    /* Laufindex fuer die Ausgabe */

 /* Funktionsaufruf zur Berechnung der Summe */

 vektorsumme(x,y,summe,5);

 /* Ausgabe des Ergebnisses */

 printf("Die Vektorsumme von x = {");
 for (i=0;i<4;i++)
  printf(" %2d,",x[i]);
 printf(" %2d }\n",x[4]);
 printf("                und y = {");
 for (i=0;i<4;i++)
  printf(" %2d,",y[i]);
 printf(" %2d }\n\n",y[4]);
 printf("       betraegt summe = {");
 for (i=0;i<4;i++)
  printf(" %2d,",summe[i]);
 printf(" %2d }\n",summe[4]);

 getch();

}
